#pragma once

#include <filesystem>

#include "../base/ProviderSegmentBase.h"
#include "../workingmemory/ProviderSegment.h"

#include "Entity.h"


namespace armarx::armem::d_ltm
{

    /**
     * @brief Data of a provider segment containing multiple entities.
     */
    class ProviderSegment :
        public base::ProviderSegmentBase<Entity, ProviderSegment>
    {
        using Base = base::ProviderSegmentBase<Entity, ProviderSegment>;

    public:

        using Base::ProviderSegmentBase;
        using Base::operator=;


        // Conversion
        wm::ProviderSegment convert(const aron::typenavigator::NavigatorPtr& expectedStructure) const;

        // Filesystem connection
        void reload(const std::shared_ptr<std::filesystem::path>&);
        void append(const wm::ProviderSegment&);

    private:
        std::filesystem::path _fullPath() const;
        std::filesystem::path _fullPath(const std::filesystem::path&) const;

    public:
        std::shared_ptr<std::filesystem::path> path;
    };

}
