#pragma once

#include "../base/ProviderSegmentBase.h"

#include "Entity.h"

#include "../workingmemory/ProviderSegment.h"


namespace armarx::armem::ltm
{

    /**
     * @brief Data of a provider segment containing multiple entities.
     */
    class ProviderSegment :
        public base::ProviderSegmentBase<Entity, ProviderSegment>
    {
        using Base = base::ProviderSegmentBase<Entity, ProviderSegment>;

    public:

        using Base::ProviderSegmentBase;
        using Base::operator=;


        // Conversion
        wm::ProviderSegment convert() const;

        // MongoDB connection
        void reload();
        void append(const wm::ProviderSegment&);

    protected:
        virtual void _copySelf(ProviderSegment& other) const override
        {
            Base::_copySelf(other);
            other.dbsettings = dbsettings;
        }

        virtual void _copySelfEmpty(ProviderSegment& other) const override
        {
            Base::_copySelfEmpty(other);
            other.dbsettings = dbsettings;
        }

    public:
        MongoDBConnectionManager::MongoDBSettings dbsettings;
    };

}
